set echo on
clear screen
remark
remark  Bedrijfsregel "Een werknemer mag niet meer verdienen dan zijn leidinggevende."
remark
remark  Bewakingsmomenten:
remark   * Toevoegen van een nieuwe werknemer
remark   * Wijzigen van het salaris van een werknemer/leidinggevende
remark   * Wijzigen van de leidinggevende van een werknemer
remark
remark  Hier een implementatie van het eerste bewakingsmoment: toevoegen van een nieuwe werknemer
remark
create trigger emp_bri
  before insert on emp
  for each row
declare
  l_mgr_sal emp.sal%type;
begin
  select sal
    into l_mgr_sal
    from emp
   where empno = :new.mgr
  ;
  if :new.sal > l_mgr_sal
  then
    raise_application_error
    ( -20000
    , 'Een werknemer mag niet meer verdienen dan zijn leidinggevende.'
    );
  end if;
exception
when no_data_found then
  null;  -- de nieuwe werknemer heeft geen leidinggevende, dus is de validatie ok.
end;
/
pause
insert into emp (empno,ename,sal,mgr) values (8888,'VAN WIJK',9000,7839)
/
select sal from emp where empno = 7839
/
pause
insert into emp (empno,ename,sal,mgr) values (8888,'VAN WIJK',4000,7839)
/
rollback
/
pause
insert into emp (empno,ename,sal,mgr) select 8888,'VAN WIJK',4000,7839 from dual
/
set echo off
drop trigger emp_bri
/